clear all
set more off
clear matrix 


use "$inputHH2013\GSEC1", clear
replace HHID=subinstr(HHID,"-04-","",.)
keep HHID rotate
rename rotate rotate13

recode rotate13 (0=1) (1=2)
lab val rotate13 rotate13
lab def  rotate13 1 "rotated-in  in 2013/14" 2 "Covered in wave 2011/12", modify

tempfile rotate
save `rotate'

use "$inputHH2009\GSEC1", clear
destring HHID, gen(HHID_old)
rename HHID HHID09
merge 1:m HHID_old using "$inputHH2013\GSEC1", keepusing(HHID HHID_old ea) gen(m1)
replace HHID=subinstr(HHID,"-04-","",.)

merge m:1 HHID using "$inputHH2015\gsec1", keepusing(HHID)

keep  if m1==1&_m!=3

drop HHID 
rename HHID09 HHID
gen rotatedout=1 if m1==1&_m!=3
drop _m

preserve
duplicates drop rotatedout ea comm, force
duplicates tag comm, g(test)
gen d=rotatedout==1&test==0
*replace rotatedout=0 if test!=0
*drop test
keep if d==1 
keep comm d
duplicates drop
count
tempfile a
save `a'
restore
count
merge m:1 comm using `a', nogen keep (1 3)
replace rotatedout=0 if d!=1
drop d
recode rotatedout (.=0) 

lab def rotatedout 1 "Households dropped out of the sample during refresh"
lab val rotatedout rotatedout
keep HHID rotatedout

tempfile rotout
save `rotout'

use  "$inputHH2010\GSEC2", clear
rename  h2q11  h2q11_10
rename  h2q12  h2q12_10
 
lab val h2q12_10 h2q12_10 
lab def  h2q12_10  2 "Returned home from abduction/displacement" 4 "Bad living conditions at home" 5 "To look for work" 8 "Marriage" 9 "Divorce" 10 "Deceased" 11 "To escape insecurity from this area" ///
          12 "Looking for work elsewhere" 13 "Other economic reasons" 14 "Illness" 15 "Education" 18 "Started own household" 19 "Abducted/disappeared" 20 "Other (specify)", modify
		  
keep HHID PID h2q11_10 h2q12_10
tempfile GSEC210
save `GSEC210'

use  "$inputHH2011\GSEC2", clear
rename  h2q11  h2q11_11
rename  h2q12  h2q12_11
duplicates tag PID, g(DUP11)

lab val h2q12_11 h2q12_11
lab def  hh2q12_11   2 "Returned home from abduction/displacement" 4 "Bad living conditions at home" 5 "To look for work" 8 "Marriage" 9 "Divorce" 10 "Deceased" 11 "To escape insecurity from this area" ///
          12 "Looking for work elsewhere" 13 "Other economic reasons" 14 "Illness" 15 "Education" 18 "Started own household" 19 "Abducted/disappeared" 20 "Other (specify)", modify

keep HHID PID h2q11_11 h2q12_11 DUP11
tempfile GSEC211
save `GSEC211'


use  "$inputHH2005\GSEC2", clear
merge m:1 HHID using "$inputHH2005\GSEC1", keep (3) nogen

*use  "$inputHH2005\2005_GSEC2", clear
*rename HHID Hhid
*merge m:1 Hhid using "$inputHH2005\2005_GSEC1", keep (3) nogen
rename h2q13  h2q11_05
rename h2q14  h2q12_05
*rename Hhid HHID

lab val h2q12_05 h2q12_05
lab def h2q12_05 2 "Returned home from abduction/displacement" 4 "Bad living conditions at home" 5 "To look for work" 8 "Marriage" 9 "Divorce" 10 "Deceased" 11 "To escape insecurity from this area" ///
          12 "Looking for work elsewhere" 13 "Other economic reasons" 14 "Illness" 15 "Education" 18 "Started own household" 19 "Abducted/disappeared" 20 "Other (specify)", modify

keep HHID PID h2q11_* h2q12_* tracking_sample

gen HHID05=HHID
rename HHID HHID_old
gen PID05=PID 
rename PID PID_Old

gen y2005=1

tempfile w05
save `w05'


use "$inputHH2009\GSEC1", clear
merge 1:1 HHID using `rotout', keepusing(rotatedout) nogen 
merge 1:m HHID using"$inputHH2009\GSEC2", keep (3) nogen

*use "$inputHH2009\2009_GSEC1", clear
*merge 1:1 HHID using `rotout', keepusing(rotatedout) nogen 
*merge 1:m HHID using"$inputHH2009\2009_GSEC2", keep (3) nogen

drop if  h2q7==7

merge m:1 HHID PID using `GSEC210', keep (1 3)  nogen
merge m:1 HHID PID using `GSEC211', keep (1 3)  nogen

rename  h2q11  h2q11_09
rename  h2q12  h2q12_09
 

lab val h2q12_09  h2q12_09
lab def h2q12_09 2 "Returned home from abduction/displacement" 4 "Bad living conditions at home" 5 "To look for work" 8 "Marriage" 9 "Divorce" 10 "Deceased" 11 "To escape insecurity from this area" ///
          12 "Looking for work elsewhere" 13 "Other economic reasons" 14 "Illness" 15 "Education" 18 "Started own household" 19 "Abducted/disappeared" 20 "Other (specify)", modify

		  recode h2q12_09 (6=13) (7=15) (16=8) (17=9) (0 1 =.)

keep HHID PID h2q11_* h2q12_* DUP11  rotatedout 

gen HHID09=HHID
rename HHID HHID_old

gen PID09=PID 
rename PID PID_Old

gen y2009=1

tempfile w09
save `w09'

use  "$inputHH2013\GSEC2", clear //* Variable on the reason for the household member to live is missing.
duplicates report PID

duplicates tag PID_Old, g(test)
drop if test==1 & HHID_old==.
drop if test==1 & (wgt==.|wgt==0)
* still have 4 duplicates. 
drop if test==1 & HHID_old==2113000905&PID=="P22110-011"
drop if test==1 & HHID_old==211300090504&PID=="P16505-004"

duplicates drop PID, force

rename h2q11 h2q11_13
/*--------------------------------------
   copies | observations       surplus
----------+---------------------------
        1 |        17360             0
        2 |           36            18
--------------------------------------*/


rename HHID HHID13
gen PID13=PID
gen HHID=subinstr(HHID13,"-04-","",.)

tostring HHID_old, force replace format(%20.0g)

rename h2q6 h2q6_15
rename h2q5 h2q5_15
keep HHID PID PID_Old  HHID_old  h2q11_* h2q6_15 h2q5_15
gen y2013=1 
gen HHID13=HHID
gen PID13=PID
tempfile w13
save `w13'

preserve
keep if PID_Old==""
tempfile w13A
save `w13A' 
restore

preserve
keep if PID_Old!=""
tempfile w13B
save `w13B' 
restore

use  "$inputHH2015\gsec2", clear //-  There are 2905 observation with all vars missing.
gen HHID=hhid
merge m:1 HHID using "$inputHH2015\gsec1", keep(3)  nogen keepusing(HHID nonresp rotate)

drop if h2q7==7|h2q7==10|h2q7==6
duplicates tag pid, g(tag)
drop if h2q6>=10&h2q6<20&tag==1
drop if h2q5<6&tag==1
* still 4 duplicates I am removing.
duplicates drop pid, force

rename h2q11 h2q11_15
rename h2q6 h2q6_15
rename h2q5 h2q5_15

keep HHID pid h2q11_15 h2q6 h2q5_15 nonresp rotate
rename rotate rotate15

recode rotate15 (0=1) (1=2)
lab val rotate15 rotate15
lab def  rotate15 1 "rotated-in  in 2013/14" 2"Covered in wave 2011/12", modify

gen y2015=1
gen HHID15=HHID
gen PID15=pid
tempfile w15
save `w15'

use  `w05'
merge 1:1 PID_Old using `w09', nogen
merge 1:1  PID_Old using  `w13B', //nogen

append using `w13A'
count

tempfile w0913
save `w0913'

use `w13', clear
gen pid=PID
merge 1:1  pid using `w15'
 
gen hhid=HHID
drop PID
gen PID=pid 
merge m:1 HHID using `rotate', nogen
isid HHID PID
tempfile w1315
save `w1315'

use `w0913', clear
gen hhid=HHID
replace hhid = HHID_old if hhid==""
gen pid=PID
replace pid=PID_Old if pid==""
merge 1:1 hhid pid using `w1315', nogen

lab var hhid "panel household identifier"
lab var pid  "panel person identifier"
lab var HHID05 "HHID 2005"
lab var PID05 "PID 2005"
lab var HHID09 "HHID 2009"
lab var PID09 "PID 2009"
lab var y2009 "==09 if Person in 2009"
lab var HHID13 "HHID 2013"
lab var PID13  "PID 2013"
lab var y2013 "==13 if Person in 2013"
lab var HHID15 "HHID 2015"
lab var PID15 "PID 2015"
lab var y2015 "==15 if Person in 2013"

order hhid pid HHID05 PID05 y2005 HHID09 PID09 y2009 HHID13 PID13 y2013 HHID15 PID15 y2015 rotatedout 
keep HHID05 PID05 y2005 HHID09 PID09 y2009 y2013 HHID13 PID13 y2015 HHID15 PID15 hhid pid h2q11_*  h2q12_* rotate* rotatedout 


recode rotatedout (1=.) if y2013!=. | y2015!=.

recode y2005 y2009 y2013 y2015 (.=0)
tostring y2005 y2009 y2013 y2015, force replace
replace y2005="05" if y2005=="1"
replace y2009="09" if y2009=="1"
replace y2013="13" if y2013=="1"
replace y2015="15" if y2015=="1"

egen attrition=concat(y2005 y2009 y2013 y2015 ), punct("_")

gen dleft09=1 if h2q11_05==2&attrition=="05_0_0_0" 
gen left09=h2q12_05 if attrition=="05_0_0_0"

gen dleft13=1 if rotatedout==1
replace dleft13=1 if h2q11_05==2 & dleft13==.&attrition=="05_0_0_0"
replace dleft13=1 if h2q11_09==2 & dleft13==.&attrition=="05_09_0_0"

replace dleft13=1 if h2q11_09==2 & dleft13==.&attrition=="0_09_0_0"
replace dleft13=1 if h2q11_10==2 &  dleft13==.&attrition=="05_09_0_0"
replace dleft13=1 if h2q11_10==2 &  dleft13==.&attrition=="0_09_0_0"

replace dleft13=1 if h2q11_11==2 &  dleft13==.&attrition=="05_09_0_0"
replace dleft13=1 if h2q11_11==2 &  dleft13==.&attrition=="0_09_0_0"
 
gen left13=-99 if rotatedout==1

replace left13=h2q12_05 if left13==.&attrition=="05_0_0_0"
replace left13=h2q12_09 if left13==.&attrition=="05_09_0_0"
replace left13=h2q12_09 if left13==.&attrition=="0_09_0_0"
replace left13=h2q12_10 if left13==.&attrition=="05_09_0_0"
replace left13=h2q12_10 if left13==.&attrition=="0_09_0_0"
replace left13=h2q12_11 if left13==.&attrition=="05_09_0_0"
replace left13=h2q12_11 if left13==.&attrition=="0_09_0_0"
 
gen dleft15=1 if h2q11_13==2 &attrition=="05_09_13_0" | attrition=="05_0_13_0" | attrition=="05_09_13_0" | attrition=="0_09_13_0"

drop h2q11_05 h2q12_05 h2q11_09 h2q12_09 h2q11_10 h2q12_10 h2q11_11 h2q12_11 h2q11_13

lab val left13  left13
lab def left13 -99 "Rotated out" 2 "Returned home from abduction/displacement" 4 "Bad living conditions at home" 5 "To look for work" 8 "Marriage" 9 "Divorce" 10 "Deceased" 11 "To escape insecurity from this area" ///
          12 "Looking for work elsewhere" 13 "Other economic reasons" 14 "Illness" 15 "Education" 18 "Started own household" 19 "Abducted/disappeared" 20 "Other (specify)", modify


lab var rotatedout "==1 if Individual is out because of panel rotation"
lab var rotate13     "==1 if individual is rotated-in (NEW)"
lab var rotate15     "==1 if individual is rotated-in (NEW)"

lab var attrition  "Individual participation across round"
lab var dleft13    "Household not in round 13/14 declared she left "
lab var left13     "Reason nor leaving before round 13/14"
lab var dleft15    "Household not in round 15/16 declared she left "

save "$tempfiles\unps_09_13_15.dta", replace
ex 


