clear all
set more off
clear matrix 

* datasets microdatalib
/*use "$inputHH2005\2005_GSEC18", clear
rename Hhid HHID
keep HHID H18q1 H18q2
rename HHID HHID05
rename H18q1 h19q1_05
rename H18q2 h19q2_05
tempfile ag1
save `ag1'

use "$inputHH2005\2005_GSEC1", clear

rename Hhid HHID
keep HHID Region Substrat /*H1aq1_05*/ Districtc09 Districtc05 Tracking_sample /*Stratum*/ Hmult Comm

gen stratum=.
replace stratum = 1 if Districtc05=="102"
replace stratum = 2 if Districtc05!="102" & Substrat==1
replace stratum = 3 if Region==1 & Substrat==3
replace stratum = 4 if Region==2 & Substrat==3
replace stratum = 5 if Region==3 & Substrat==3
replace stratum = 6 if Region==4 & Substrat==3

lab val stratum stratum 
lab def stratum 1 "Kampala" 2 "Other urban" 3 "Central rural" 4 "East rural" 5 "North rural" 6 "West rural", modify

destring Districtc09 Comm, force replace
rename stratum stratum05
rename HHID HHID05
rename Region  region05
rename Substrat urban05 

gen regurb05= 1 if Districtc05=="102"
replace regurb05=10 if region05==1 & urban05==3 & regurb05==.
replace regurb05=11 if region05==1 & urban05==1 & regurb05==.
replace regurb05=20 if region05==2 & urban05==3 & regurb05==.
replace regurb05=21 if region05==2 & urban05==1 & regurb05==.
replace regurb05=30 if region05==3 & urban05==3 & regurb05==.
replace regurb05=31 if region05==3 & urban05==1 & regurb05==.
replace regurb05=40 if region05==4 & urban05==3 & regurb05==.
replace regurb05=41 if region05==4 & urban05==1 & regurb05==.

lab val regurb05 regurb05
lab def regurb05 1 "Kampala" 10 "Central Urban" 11 "Central Rural" 20 "East Urban" 21 "East Rural" 30 "North Urban" 31 "North Rural" 30 "West Urban" 31 "West Rural", modify

*rename stratum  stratum05
rename Hmult  Xwgt05
rename Districtc09  DistrictC_09
rename Comm   com_05
merge 1:1 HHID05 using `ag1', keep(1 3) nogen

save "$tempfiles\GEO_Weights05.dta", replace
*/


* own data

use "$inputHH2005\GSEC18", clear
keep HHID h18q1 h18q2
rename HHID HHID05
rename h18q1 h19q1_05
rename h18q2 h19q2_05
tempfile ag1
save `ag1'

use "$inputHH2005\GSEC1", clear

keep HHID region urban h1aq1_05 tracking_sample stratum hmult comm

rename HHID HHID05
rename region  region05
rename urban urban05 

gen regurb05= 1 if region==0
replace regurb05=10 if region==1 & urban==0
replace regurb05=11 if region==1 & urban==1
replace regurb05=20 if region==2 & urban==0
replace regurb05=21 if region==2 & urban==1
replace regurb05=30 if region==3 & urban==0
replace regurb05=31 if region==3 & urban==1
replace regurb05=40 if region==4 & urban==0
replace regurb05=41 if region==4 & urban==1

lab val regurb05 regurb05
lab def regurb05 1 "Kampala" 10 "Central Urban" 11 "Central Rural" 20 "East Urban" 21 "East Rural" 30 "North Urban" 31 "North Rural" 30 "West Urban" 31 "West Rural", modify

rename stratum  stratum05
rename hmult  Xwgt05
rename h1aq1_05  DistrictC_09
rename comm   com_05
merge 1:1 HHID05 using `ag1', keep(1 3) nogen

save "$tempfiles\GEO_Weights05.dta", replace


use "$inputHH2009\GSEC1", clear

keep HHID region urban regurb stratum wgt09wosplits wgt09 h1aq1 h1aq2 h1aq2b h1aq3 h1aq3b h1aq4 h1aq4b comm h19q1 h19q2 hh_status

rename HHID HHID09
rename region  region09
rename urban urban09 
rename regurb  regurb09
rename stratum  stratum09
rename wgt09wosplits  Xwgt09
rename h1aq1  DistrictC_09
rename h1aq2  CountyC_09
rename h1aq2b CountyN_09
rename h1aq3  SubCountyC_09
rename h1aq3b SubCountyN_09
rename h1aq4  ParishC_09
rename h1aq4b ParishN_09
rename comm   com_09
rename h19q1 h19q1_09 
rename h19q2 h19q2_09
rename hh_status hh_status_09

save "$tempfiles\GEO_Weights09.dta", replace

use "$inputHH2013\GSEC19", clear
keep HHID h19q1 h19q2
rename HHID HHID13
rename h19q1 h19q1_13
rename h19q2 h19q2_13
tempfile ag
save `ag'

use "$inputHH2013\GSEC1", clear
keep HHID h1aq1a h1aq3a h1aq3b h1aq4a h1aq4b region regurb sregion urban ea wgt_X wgt DynID
rename HHID HHID13
rename region  region13
rename urban urban13 
rename regurb  regurb13
rename wgt_X  Xwgt13
rename wgt wgt13
rename h1aq3b SubCountyN_13
rename h1aq4a  ParishC_13
rename h1aq4b ParishN_13
rename ea   ea_13
rename DynID DynID13
merge 1:1 HHID using `ag', keep(1 3) nogen
save "$tempfiles\GEO_Weights13.dta", replace


use "$inputHH2015\gsec19", clear
keep hhid h19q1 h19q2
rename hhid HHID15
rename h19q1 h19q1_15
rename h19q2 h19q2_15
tempfile ag2
save `ag2'


use "$inputHH2015\gsec1", clear
 
keep ea HHID district district_name  scounty_code subcounty_name parish_code  parish_name  h1aq5 urban hwgt_W4_W5 hwgt_W5 h_xwgt_W5  region   regurb sregion  DynID 
rename  HHID  		   HHID15
rename  district       DistrictC_15
rename  district_name  DistrictN_15
rename  scounty_code   CountyC_15
rename  subcounty_name CountyN_15
rename  parish_code    ParishC_15
rename  parish_name    ParishN_15
rename  ea          ea_15
rename  urban          urban15
rename  hwgt_W4_W5     hwgt_13_15
rename  hwgt_W5        wgt15
rename  h_xwgt_W5      Xwgt15
rename region          region15
rename regurb          regurb15
rename sregion         sregion15
*rename rotate          rotate15
rename DynID 			DynID15

gen stratum_15=1 if DistrictC_15==102
replace stratum_15=2 if inlist(regurb,11,21,31,41) & DistrictC_15!=102
replace stratum_15=3 if regurb==10
replace stratum_15=4 if regurb==20
replace stratum_15=5 if regurb==30
replace stratum_15=6 if regurb==40

gen regionUNHS= 1 if DistrictC_15==102
replace regionUNHS= 2 if DistrictC_15==113
replace regionUNHS= 3 if region15==1 & regionUNHS==.
replace regionUNHS= 4 if region15==2 & regionUNHS==.
replace regionUNHS= 5 if region15==3 & regionUNHS==.
replace regionUNHS= 6 if region15==4 & regionUNHS==.

lab define regionUNHS 1 "Kampala" 2"Wakiso" 3 "Central" 4 "Eastern" 5 "Northern" 6 "Western", modify
lab val regionUNHS regionUNHS


merge 1:1 HHID using `ag2', keep(1 3) nogen

save "$tempfiles\GEO_Weights15.dta", replace


*data from microdata lab \\ use "$inputHH2005\2005_GSEC2", clear
use "$inputHH2005\GSEC2", clear

bys HHID: egen hhsize=count(PID) if tid<=4
lab var hhsize "Household size"
keep HHID PID  h2q4 h2q5  h2q9 h2q10 

rename HHID  HHID05 
rename PID PID05
*rename h2q1 h2q1_09
rename h2q4  sex_05
rename h2q5 relationtohead_05
*rename h2q6 reasonnohome_09
rename h2q9 age_05
rename h2q10 marital_05

save "$tempfiles\individual1_05.dta", replace

use "$inputHH2009\GSEC2", clear

bys HHID: egen hhsize=count(h2q1) if h2q7<=4
lab var hhsize "Household size"
keep HHID PID h2q1 h2q3 h2q4 h2q6 h2q8 h2q10 hhsize

rename HHID  HHID09 
rename PID PID09
*rename h2q1 h2q1_09
rename h2q3  sex_09
rename h2q4 relationtohead_09
*rename h2q6 reasonnohome_09
rename h2q8 age_09
rename h2q10 marital_09
rename hhsize hhsize_09

save "$tempfiles\individual1_09.dta", replace

use "$inputHH2013\GSEC2", clear

bys HHID: egen hhsize=count(h2q1) if h2q7<=4
lab var hhsize "Household size"

keep HHID PID h2q1 h2q3 h2q4 h2q6 h2q8 h2q10 hhsize
rename HHID  HHID13 
rename PID PID13
*rename h2q1 h2q1_13
rename h2q3  sex_13
rename h2q4 relationtohead_13
*rename h2q6 reasonnohome_13
rename h2q8 age_13
rename h2q10 marital_13
rename hhsize hhsize_13

save "$tempfiles\individual1_13.dta", replace

use "$inputHH2015\GSEC2", clear

bys hhid: egen hhsize=count(h2q1) if h2q7<=4
lab var hhsize "Household size"

keep hhid pid h2q1 h2q3 h2q4 h2q6 h2q8 h2q10 hhsize
rename hhid  HHID15 
rename pid PID15
*rename h2q1 h2q1_15
rename h2q3  sex_15
rename h2q4 relationtohead_15
*rename h2q6 reasonnohome_15
rename h2q8 age_15
rename h2q10 marital_15
rename hhsize hhsize_15

save "$tempfiles\individual1_15.dta", replace
**# Bookmark #1

use "$inputHH2009\GSEC3", clear

keep HHID PID h3q9 h3q13 h3q14 h3q15 h3q16  h3q18 h3q19

rename  HHID HHID09
rename  PID PID09
rename  h3q9 enthnicity_09
rename  h3q13 district_born_09
rename  h3q14 district_5yrago_09
rename  h3q15 nb_yrsXdistrict_09
rename  h3q16 district_b_moving_09
rename  h3q18 reason_moving_09

recode enthnicity_09 (68=96)
lab def enthnicity_09  11	"Acholi" 12	"Alur" 13	"Baamba" 14	"Babukusu"  15	"Babwisi" 16	"Bafumbira" 17	"Baganda" 18	"Bagisu" ///
19	"Bagungu" 20	"Bagwe" 21 	"Bagwere" 22 "Bahehe"  23	"Bahororo" 24	"Bakenyi" 25	"Bakiga" 26	"Bakhonzo" 27 "Banyabindi"  ///
28	"Banyakole" 29	"Banyara" 30	"Banyarwanda" 31	"Banyole" 32	"Banyoro" 33	"Baruli" ///
34	"Basamia" 35	"Basoga" 36 "Basongora"  37	"Batagwenda" 38	"Batoro" 39 "Batuku"  40 "Batwa"  41	"Chope" 42	"Dodoth" 43	"Ethur" 44	"Ik (Teuso)" ///
45	"Iteso" 46 "Indian"  47	"Japadhola" 48	"Jie" 49	"Jonam" 50	"Kakwa" 51	"Karimojong" 52 "Kebu" 53 "Kuku"   54	"Kumam" 55	"Langi" ///
56	"Lendu" 57	"Lugbara" 58	"Madi" 59 "Mening"  60 "Mvuba"  61 "Napore"  62	"Nubi" 63 "Nyangia" 64 "Pokot"  65	"Sabiny" 66 "So (Tepeth)"  67 "Vonoma" 69	"Aliba" 70	"Aringa" 72	"Banyaruguru" ///
73	"Barundi" 74	"Gimara" 76	"Reli" 96	"Other (Specify)", modify

lab val enthnicity_09 enthnicity_09

gen region_born_09=.
replace region_born_09=1 if inrange(district_born_09,100,199)&region_born_09==.
replace region_born_09=2 if inrange(district_born_09,200,299)&region_born_09==.
replace region_born_09=3 if inrange(district_born_09,300,399)&region_born_09==.
replace region_born_09=4 if inrange(district_born_09,400,499)&region_born_09==.
lab var region_born_09 "In which region was [NAME] born?"

gen region_b_moving_09=.
replace region_b_moving_09=1 if inrange(district_b_moving_09,100,199)&region_b_moving_09==.
replace region_b_moving_09=2 if inrange(district_b_moving_09,200,299)&region_b_moving_09==.
replace region_b_moving_09=3 if inrange(district_b_moving_09,300,399)&region_b_moving_09==.
replace region_b_moving_09=4 if inrange(district_b_moving_09,400,499)&region_b_moving_09==.
lab var region_b_moving_09 "In which region did [NAME] live before moving to current place of residence?"
                                                
save "$tempfiles\individual2_09.dta", replace

use "$inputHH2013\GSEC3", clear
keep HHID PID h3q9 h3q13R h3q13D h3q14R h3q14D h3q15 h3q16R h3q16D  h3q18 h3q19

rename  HHID HHID13
rename  PID PID13
rename  h3q9 enthnicity_13
 
rename  h3q13D district_born_13
rename  h3q13R region_born_13
rename  h3q14D district_5yrago_13
rename  h3q14R region_5yrago_13
rename  h3q15 nb_yrsXdistrict_13
rename  h3q16R region_b_moving_13
rename  h3q16D district_b_moving_13

rename  h3q18 reason_moving_09

save "$tempfiles\individual2_13.dta", replace

use "$inputHH2015\gsec3", clear

keep hhid pid h3q9 h3q13R h3q13D h3q14R h3q14D h3q15 h3q16R h3q16D  h3q18 h3q19

rename  hhid HHID15
rename  pid PID15
rename  h3q9 enthnicity_15
rename  h3q13D district_born_15
rename  h3q13R region_born_15

rename  h3q14D district_5yrago_15
rename  h3q14R region_5yrago_15

rename  h3q15 nb_yrsXdistrict_15
rename  h3q16D country_b_moving_15
rename  h3q16R region_b_moving_15
rename  h3q18 reason_moving_15
save "$tempfiles\individual2_15.dta", replace


use "$inputHH2009\UNPS 2009-10 Consumption Aggregate", clear
*use "$inputHH2009\pov2009_10", clear
*rename hhid HHID
keep HHID cpexp30 

tostring HHID, g(HHID09) force format(%20.0g)
drop HHID
rename cpexp30 cpexp30_09
save "$tempfiles\UNPS 2009-10 Consumption Aggregate.dta", replace

use "$inputHH2013\UNPS 2013-14 Consumption Aggregate", clear
duplicates drop
keep HHID cpexp30 

rename HHID HHID13
rename cpexp30 cpexp30_13
save "$tempfiles\pov_13.dta", replace

use "$inputHH2015\pov2015_16.dta", clear
keep hh cpexp30 

rename hh HHID15
replace HHID15=subinstr(HHID15,"-05-","",.)

rename cpexp30 cpexp30_15
save "$tempfiles\pov_15.dta", replace

ex
