clear all
set more off
clear matrix 


insheet using "$inputdata\Rulis_Uganda_10_\hh_final.csv", clear
format hhid %18,0f
drop weight_hh
for var psu-dem_dep_ratio: rename X X09
count //2975
tempfile hh09
save `hh09'

insheet using "$inputdata\Rulis_Uganda_10_\individual_final.csv", clear
format hhid %18,0f
format id_code %18,0f
for var urban sex- ref_population_sdg5a1: rename X X09
count //17,678
tempfile ind09
save `ind09'

merge m:1 hhid using  `hh09', nogen

tostring id_code, force replace format(%20.0g)

rename id_code PID09

tostring hhid, g(HHID09) force 
format HHID09 %18s
format PID09 %18s
drop hhid 
*rename hhid HHID09

keep HHID09 PID09 urban09 HHID09 PID09 poor09 tot_employment09 lit_pop09 employees09 employer09 self_employment09 industry109 dem_dep_ratio09 totincome09 pcinc09 cellphone09 electricity09 safewater09 ownhome09 runwater09 roomsno09 brickwalls09 nondirtfloor09 solidroof09 internet09 toilet09 dagr_quest09
count //17,678
tempfile rulis09
save `rulis09'

insheet using "$inputdata\Rulis_Uganda_14_\hh_final.csv", clear
format hhid %18s
drop weight_hh

for var psu-dem_dep_ratio: rename X X13
count // 3,117
tempfile hh13
save `hh13'

insheet using "$inputdata\Rulis_Uganda_14_\individual_final.csv", clear
format hhid %18s
format id_code %18s

for var urban sex- ref_population_sdg5a1: rename X X13
// 17414

tempfile ind13
save `ind13'

merge m:1 hhid using  `hh13', nogen

rename id_code PID13
rename hhid HHID13

keep HHID13 PID13 urban13 HHID13 PID13 poor13 tot_employment13 lit_pop13 employees13 employer13 self_employment13 industry113 dem_dep_ratio13 totincome13 pcinc13 cellphone13 electricity13 safewater13 ownhome13 runwater13 roomsno13 brickwalls13 nondirtfloor13 solidroof13 internet13 toilet13 dagr_quest13

duplicates drop HHID13 PID13, force
tempfile rulis13
count  //17396
save `rulis13'

insheet using "$inputdata\Rulis_Uganda_16_\hh_final.csv", clear
format hhid %18s
drop weight_hh

for var psu-dem_dep_ratio: rename X X15
count // 3256
tempfile hh15
save `hh15'

insheet using "$inputdata\Rulis_Uganda_16_\individual_final.csv", clear
format hhid %18s
format id_code %18s

for var urban sex- ref_population_sdg5a1: rename X X15

count // 3256
tempfile ind15
save `ind15'

merge m:1 hhid using  `hh15', nogen

rename id_code PID15
rename hhid HHID15

keep HHID15 PID15 urban15 HHID15 PID15 poor15 tot_employment15 lit_pop15 employees15 employer15 self_employment15 industry115 dem_dep_ratio15 totincome15 pcinc15 cellphone15 electricity15 safewater15 ownhome15 runwater15 roomsno15 brickwalls15 nondirtfloor15 solidroof15 internet15 toilet15 dagr_quest15
count // 15654
tempfile rulis15
save `rulis15'

use "$tempfiles\GEO_Weights05.dta", clear
merge 1:m HHID05 using "$tempfiles\individual1_05.dta", nogen
// 16759
tempfile y05
save `y05'

use "$tempfiles\GEO_Weights09.dta", clear
merge 1:m HHID09 using "$tempfiles\individual1_09.dta", nogen
merge 1:1 HHID09 PID09 using "$tempfiles\individual2_09.dta", nogen
merge 1:1 /*HHID09*/ PID09 using `rulis09', 
merge m:1 HHID09 using "$tempfiles\pov_09.dta", nogen
//18734

tempfile y09
save `y09' 

use  "$tempfiles\GEO_Weights13.dta", clear
merge 1:m HHID13 using "$tempfiles\individual2_13.dta", nogen
merge 1:1 HHID13 PID13 using "$tempfiles\individual1_13.dta", nogen
merge 1:1 HHID13 PID13 using `rulis13', nogen

merge m:1 HHID13 using "$tempfiles\pov_13.dta", nogen //keep(1 3)
replace HHID13=subinstr(HHID13,"-04-","",.)
// 17510 
tempfile y13
save `y13' 

use  "$tempfiles\GEO_Weights15.dta", clear
merge 1:m HHID15 using "$tempfiles\individual1_15.dta", nogen
merge 1:1 HHID15 PID15 using "$tempfiles\individual2_15.dta", nogen

merge 1:1 HHID15 PID15 using `rulis15', nogen

*rename sex_15 sex_15a
*rename hhsize_15 hhsize_15a
merge m:1 HHID15 using "$tempfiles\pov_15.dta", nogen keep(1 3)
// 16739

tempfile y15
save `y15' 


use "$tempfiles\unps_09_13_15.dta", clear
// 05 16759
// 09 18,313
// 13 17,377  
// 15 15,905 


keep if y2005=="05"
keep hhid pid HHID05 PID05 y2005
merge m:1 HHID05 PID05 using  `y05', nogen 

tempfile panel05
save `panel05'

use "$tempfiles\unps_09_13_15.dta", clear
keep if y2009=="09"
keep hhid pid HHID09 PID09 y2009
merge m:1 HHID09 PID09 using  `y09', nogen keep(1 3)
count 
tempfile panel09
save `panel09'


use "$tempfiles\unps_09_13_15.dta", clear
keep if y2013=="13"
keep hhid pid HHID13 PID13 y2013

merge 1:1 HHID13 PID13 using  `y13',keep(1 3) nogen
count
tempfile panel13
save `panel13'

use "$tempfiles\unps_09_13_15.dta", clear
keep if y2015=="15"
keep hhid pid HHID15 PID15 y2015
isid HHID15 PID15
count 

merge 1:1 HHID15 PID15 using  `y15', keep ( 1 3)

replace hhid=HHID15 if hhid==""
replace pid=PID15 if pid==""
tempfile panel15
save `panel15'


use "$tempfiles\unps_09_13_15.dta", clear
merge 1:1 hhid pid using  `panel05', nogen
merge 1:1 hhid pid using  `panel09', nogen force
merge 1:1 hhid pid using  `panel13', nogen
merge 1:1 hhid pid using  `panel15', nogen

recode tot_employment09 (0=.) if age_09<15
recode tot_employment13 (0=.) if age_13<15
recode tot_employment15 (0=.) if age_15<15

replace lit_pop09 =. if age_09<10
replace lit_pop13 =. if age_13<10
replace lit_pop15 =. if age_15<10

// 05 16759
// 09 18,313
// 13 17,377  
// 15 15,905 


//drop if HHID15!="" & gwscal!=.

/* 
preserve 
insheet using "C:\Users\WB504830\OneDrive - WBG\Uganda Panel Weights\Datasets\Uganda_target_variable2015.txt", clear  delimiter(";") names
tempfile prova
save `prova'
restore 

merge 1:1 hhid pid using `prova', keep(3) nogen  keepusing(hhid pid)
*/
save "$tempfiles\unps_09_13_15_variables.dta", replace

export delimited using "$tempfiles\unps_09_13_15_variables.txt", delimiter(tab) replace
 
*export excel  using "$tempfiles\unps_09_13_15_variables.csv", replace  firstrow(variables) 


exit
