load(file = file.path(base_path, temp_path, "dati.RData"))
load(file = file.path(base_path, temp_path, "dati_citi.RData"))
load(file = file.path(base_path, temp_path, "Baseweight.RData"))


names(dati)
names(BaseWeight)
dk1<-dati[!is.na(dati$Xwgt13),]

dk1<-merge (dk1, datic, by="pid", all.x=T)

dk1<-dk1[!duplicated(dk1$pid), ] #nel fare il merge si creano 3 record duplicati li elimino
#P06107-001 P06107-002 P06107-005 P06107-010 P06107-019 P06107-027


names(dk1)
nrow(dk1)
table(dk1$citi)
table(dk1$newborn13)
table(dk1$year_new)

length(unique(dk1$HHID13))
dk1<-merge(dk1,BaseWeight, by="pid", all.x=T)
names(dk1)
dk1$Eligi<-ifelse(!is.na (dk1$Xwgt09),"Resp.Initial.Sample", "Blank")

dk1$Eligi<-ifelse(dk1$refresh==1,"Resp.Initial.Sample", dk1$Eligi)

dk1$Eligi<-ifelse(is.na (dk1$Xwgt09) & dk1$y2005==5,
                  "NoResp.Initial.Sample", dk1$Eligi)

dk1$Eligi<-ifelse(is.na (dk1$Xwgt09) & dk1$HHID09!="",
                  "NoResp.Initial.Sample", dk1$Eligi)

#dk1[dk1$pid=="P05109-009", ]

dk1$Eligi<-ifelse(dk1$Eligi=="Blank" & dk1$newborn13=="Newborn", 
                  "Notin.Initial.Sample",dk1$Eligi)

#dk1[dk1$pid=="P05109-009", ]


dk1$Eligi<-ifelse(dk1$Eligi=="Blank" & dk1$live.district13=="-4", "Notin.Initial.Sample",dk1$Eligi)
table(dk1$Eligi, dk1$refresh)

#there are 1539 Blank non refresh:
#they can be nonrespendent or not in the sample
#assume not response

dk1$Eligi<-ifelse(dk1$Eligi=="Blank", "NoResp.Initial.Sample",dk1$Eligi)

table(dk1$Eligi,dk1$NR2009)

#####sampled unit sampled in the initial panel sample
dk1$sampled<-ifelse(dk1$Eligi=="Notin.Initial.Sample", 0,1)
dk1$sampled<-ifelse(dk1$refresh==1,1,dk1$sampled)

table (dk1$Eligi, dk1$sampled)

#----------------------------------------------------------------------
#Variable Eligi.pop
#1 if the individual is in the target population (he/she can be sampled or not)
#0 if the individual is not in the target pop, (not. uganda or newborn) (he/she not sampled)
#----------------------------------------------------------------------

dk1$Eligi.pop<- ifelse (dk1$Eligi !="Notin.Initial.Sample", 1,0)

table(dk1$citi, dk1$sampled)
table(dk1$citi, dk1$Eligi)


dk1$Eligi.pop<- ifelse (dk1$citi=="Not.Uganda" & dk1$Eligi=="Notin.Initial.Sample",
                        0, dk1$Eligi.pop)

dk1$Eligi.pop<- ifelse (dk1$newborn13=="No.Newborn", 1, dk1$Eligi.pop)
dk1$Eligi.pop<- ifelse (dk1$refresh==1, 1, dk1$Eligi.pop)

table(dk1$Eligi.pop, dk1$Eligi, dk1$refresh)

table(dk1$Eligi.pop, dk1$Eligi)
table(dk1$Eligi.pop, dk1$sampled)
table(dk1$Eligi, dk1$sampled)

#---------------------------------------------------
#Computation of the 2013 indirect weights
#use the Xwgt.Base that are:
#the 2009 cross-sectional weights for non-refresh
#and 2013 cross-sect. for the refresh sample
#---------------------------------------------------
#names(dk1)
###################################################################
#data frame has only the 2013 respondents
#set to 0 the base weight for the new individuals new in the population
###################################################################
library(varhandle)
dk1$HHID13<-unfactor(dk1$HHID13)

dk1$W<-dk1$Xwgt.Base*dk1$sampled

#weight sum of individual in the same hh
sumwgt<-as.data.frame(tapply (dk1$W, dk1$HHID13, sum))

#individual sum selected in the sample
denominator<-as.data.frame(tapply (dk1$Eligi.pop, dk1$HHID13, sum))

sumwgt$HHID13<-rownames(sumwgt)
#sumwgt<-sumwgt[-1,]
colnames(sumwgt)<-c("SumXwgt.Base","HHID13")

denominator$HHID13<-rownames(denominator)
#denominator<-denominator[-1,]

colnames(denominator)<-c("HHden","HHID13")
table (denominator$HHden)
GWS2013<-merge(denominator, sumwgt, by="HHID13")
head(GWS2013)
GWS2013$GWS<-GWS2013$SumXwgt.Base/GWS2013$HHden

ddk1<-dk1[,c("pid", "HHID13", "Eligi.pop")]

GWS2013<-merge (ddk1, GWS2013, by="HHID13", all.x=T)


save(GWS2013, file = file.path(base_path, temp_path, "GWS2013.RData"))


rm(denominator, sumwgt, dk1,ddk1)
################################################################
#Analysis to verify the existence of hhs with only new individual
#not sampled in the 2009 and 2013
#
#105 households with new individuals were selected:
# in the 2013 refresh:  98
# in the 2009 norefresh: 8
################################################################
# names(dk1) 
# ck<-unique(dk1[c("HHID13", "new2013", "NR2009")])
#  cknew<-ck[ck$new2013=="New",]
#  cknot.new<-ck[ck$new2013!="New",]
#  ckfin<-merge (cknot.new, cknew,by ="HHID13", all=T)
#  head(ckfin)
#  ckonly.new<-ckfin[is.na (ckfin$new2013.x),]#1108 hhs with only new 
#  head(ckonly.new)
#  table (ckonly.new$NR2009.y) #91 hhs non-respondent in the norefresh sample 2013
# # 1= non response in 2009; 999 see 2013 
# #  1  999 
# # 91 1017 
# 
 # ck<-unique(dk1[c("HHID13", "new2013", "NR2013")])
 # cknew<-ck[ck$new2013=="New",]
 # cknot.new<-ck[ck$new2013!="New",]
 # ckfin<-merge (cknot.new, cknew,by ="HHID13", all=T)
 # ckonly.new<-ckfin[is.na (ckfin$new2013.x),]#103 hhs with only new 
 # table (ckonly.new$NR2013.y) #1017 hhs non-respondent in the sample 2013
# 
# # 1= non response in 2009; 999 see 2013 
# #    0  999 
# # 1017   91 
# 
# hhnew2013<-(unique(ckonly.new$HHID13))
# length(unique(ckonly.new$HHID13))
# hhnew2013
# library(varhandle)
# hhnew2013<-unfactor(hhnew2013)
# cc<-dk1[dk1$HHID13 %in% hhnew2013 ,]#208 individual in HH new 2013
# names(dk1)
# 
# table (cc$denGSW2013)# 192 individual already sampled in 2013
# ccc<-unique(cc[c("HHID13", "denGSW2013")])

#Do not exist hh with individual come from norefresh and refresh sample
#ck<-unique(dk1[c("HHID13", "flag_refresh")])
#ck<-unique(dk1[c("HHID13", "refresh")])
#cck<-as.data.frame(table(ck$HHID13))
