load(file = file.path(base_path, temp_path, "dati.RData"))
load(file = file.path(base_path, temp_path, "dati_citi.RData"))
load(file = file.path(base_path, temp_path, "Baseweight.RData"))

names(dati)
names(BaseWeight)
dk2<-dati[!is.na(dati$Xwgt15),]

dk2<-merge (dk2, datic, by="pid", all.x=T)

dk2<-dk2[!duplicated(dk2$pid), ] #nel fare il merge si creano 3 record duplicati li elimino

names(dk2)
nrow(dk2)
table(dk2$citi)
table(dk2$newborn13)
table(dk2$year_new)

length(unique(dk2$HHID15))
dk2<-merge(dk2,BaseWeight, by="pid", all.x=T)
names(dk2)

dk2$Eligi<-ifelse(!is.na (dk2$Xwgt09) & dk2$refresh==0,"Resp.Initial.Sample", "Blank")
dk2$Eligi<-ifelse(!is.na (dk2$Xwgt13) & dk2$refresh==1,
                  "Resp.Initial.Sample", dk2$Eligi)

dk2$Eligi<-ifelse(is.na (dk2$Xwgt09) & dk2$y2005==5 & dk2$refresh==0,
                  "NoResp.Initial.Sample", dk2$Eligi)

dk2$Eligi<-ifelse(is.na (dk2$Xwgt09) & dk2$HHID09!="" & dk2$refresh==0,
                  "NoResp.Initial.Sample", dk2$Eligi)

dk2$Eligi<-ifelse(is.na (dk2$Xwgt15) & dk2$HHID15!="" & dk2$refresh==1,
                  "NoResp.Initial.Sample", dk2$Eligi)

dk2$Eligi<-ifelse(dk2$Eligi=="Blank" & dk2$newborn13=="Newborn" & 
                    dk2$refresh==0, "Notin.Initial.Sample",dk2$Eligi)
dk2$Eligi<-ifelse(dk2$Eligi=="Blank" & dk2$newborn15=="Newborn" &
                    dk2$refresh==1,"Notin.Initial.Sample",dk2$Eligi)

dk2$Eligi<-ifelse(dk2$Eligi=="Blank" & dk2$live.district13=="-4" & 
                    dk2$refresh==0, "Notin.Initial.Sample",dk2$Eligi)
dk2$Eligi<-ifelse(dk2$Eligi=="Blank" & dk2$live.district15=="-4" &
                    dk2$refresh==1,"Notin.Initial.Sample",dk2$Eligi)

###################
#check coherence previous wave:ok -some 2015 Blank are Not resp in pgm for 2013
##############
# ck1<-dk1[,c("pid","Eligi")]
# ck2<-dk2[,c("pid","Eligi")]
# ck<-merge(ck1, ck2, by="pid")
# table(ck$Eligi.x,ck$Eligi.y)
#nrow(dk1)
#table(dk1$Eligi)
nrow(dk2)
table(dk2$Eligi)

dk2$Eligi<-ifelse(dk2$Eligi=="Blank", "NoResp.Initial.Sample",dk2$Eligi)

table(dk2$Eligi, dk2$refresh)

table(dk2$Eligi,dk2$NR2009)
table(dk2$Eligi,dk2$NR2013)

#####sampled unit sampled in the initial panel sample
dk2$sampled<-ifelse(dk2$Eligi=="Notin.Initial.Sample", 0,1)

table (dk2$Eligi, dk2$sampled)

#----------------------------------------------------------------------
#Variable Eligi.pop
#1 if the individual is in the target population (he/she can be sampled or not)
#0 if the individual is not in the target pop, (not. uganda or newborn) (he/she not sampled)
#----------------------------------------------------------------------

################

dk2$Eligi.pop<- ifelse (dk2$Eligi !="Notin.Initial.Sample", 1,0)

table(dk2$citi, dk2$sampled)
table(dk2$citi, dk2$Eligi)#no citi blank for new indiv, in pop.

dk2$Eligi.pop<- ifelse (dk2$citi=="Not.Uganda" & dk2$Eligi=="Notin.Initial.Sample",
                        0, dk2$Eligi.pop)

dk2$Eligi.pop<- ifelse (dk2$newborn13=="No.Newborn", 1, dk2$Eligi.pop)
dk2$Eligi.pop<- ifelse (dk2$refresh==1, 1, dk2$Eligi.pop)

table(dk2$Eligi.pop, dk2$Eligi, dk2$refresh)

table(dk2$Eligi.pop, dk2$Eligi)
table(dk2$Eligi.pop, dk2$sampled)
table(dk2$Eligi, dk2$sampled)

###################
#check coherence previous wave
##############
 # cck1<-dk1[,c("pid","Eligi.pop")]
 # cck2<-dk2[,c("pid","Eligi.pop")]
 # cck<-merge(cck1, cck2, by="pid")
 # table(cck$Eligi.pop.x,cck$Eligi.pop.y)
 # 
 # table(cck1$Eligi.pop)
 # table(cck2$Eligi.pop)
 
#---------------------------------------------------
#Computation of the 2015 indirect weights
#use the Xwgt.Base that are:
#the 2009 cross-sectional weights for non-refresh
#and 2013 cross-sect. for the refresh sample
#---------------------------------------------------
#names(dk2)
###################################################################
#data frame has only the 2015 respondents
#set to 0 the base weight for the new individuals in the sample
###################################################################
library(varhandle)
dk2$HHID15<-unfactor(dk2$HHID15)

dk2$W<-dk2$Xwgt.Base*dk2$sampled

#weight sum of individual in the same hh
sumwgt<-as.data.frame(tapply (dk2$W, dk2$HHID15, sum))

#individual sum selected in the sample
denominator<-as.data.frame(tapply (dk2$Eligi.pop, dk2$HHID15, sum))

sumwgt$HHID15<-rownames(sumwgt)
#sumwgt<-sumwgt[-1,]
colnames(sumwgt)<-c("SumXwgt.Base","HHID15")

denominator$HHID15<-rownames(denominator)
#denominator<-denominator[-1,]

colnames(denominator)<-c("HHden","HHID15")
table (denominator$HHden)
GWS2015<-merge(denominator, sumwgt, by="HHID15")
head(GWS2015)
GWS2015$GWS<-GWS2015$SumXwgt.Base/GWS2015$HHden

#######################################################
#EXtra step: computation baseweights
#######################################################
xxx<-GWS2015[GWS2015$GWS==0 ,]

nrow(xxx)#18 households with GWS=0 (create 1 household with HHID2015=NA)
xxx<-xxx[!is.na(xxx$HHID15),]
xxx$HHID15<-as.factor(xxx$HHID15)
xxx$HHID15<-unfactor(xxx$HHID15)
pp<-as.factor(xxx$HHID15)
pp<-unfactor(pp)

# library(varhandle)
zz<-dk2[dk2$HHID15 %in% pp,]#36 individuals in the households with 0 baseweight
table(zz$Eligi, zz$refresh) #classified as notin.Initial.sample
table(zz$Eligi, zz$newborn15) #classified as notin.Initial.sample
zz$Eligi<-ifelse(zz$newborn15!="Newborn", "NoResp.Initial.Sample", 
                 zz$Eligi)
zz$sampled<-ifelse(zz$Eligi=="Notin.Initial.Sample", 0,1)
zz$Eligi.pop<-ifelse(zz$Eligi=="NoResp.Initial.Sample",1,0)
table(zz$Eligi.pop, zz$Eligi)

zz<-zz[, c("HHID15", "Eligi", "sampled", "Eligi.pop")]
colnames(zz)<-c("HHID15", "Eligi.adj", "sampled.adj", "Eligi.pop.adj")
zz$HHID15<-as.factor(zz$HHID15)
zz$HHID15<-unfactor(zz$HHID15)
nrow(dk2)
dk2<-merge (dk2, zz, by="HHID15" , all.x=T)
dk2<-dk2[!duplicated(dk2$pid), ]

dk2$Eligi<-ifelse(!is.na(dk2$Eligi.adj), dk2$Eligi.adj,
                   dk2$Eligi)
dk2$Eligi.pop<-ifelse(!is.na(dk2$Eligi.pop.adj), dk2$Eligi.pop.adj,
                  dk2$Eligi.pop)
dk2$sampled<-ifelse(!is.na(dk2$sampled.adj), dk2$sampled.adj,
                      dk2$sampled)

###################################################################
#Remake the GWS computation
#data frame has only the 2015 respondents
#set to 0 the base weight for the new individuals in the sample
###################################################################
library(varhandle)
#dk2$HHID15<-unfactor(dk2$HHID15)

dk2$W<-dk2$Xwgt.Base*dk2$sampled

#weight sum of individual in the same hh
sumwgt<-as.data.frame(tapply (dk2$W, dk2$HHID15, sum))

#individual sum selected in the sample
denominator<-as.data.frame(tapply (dk2$Eligi.pop, dk2$HHID15, sum))

sumwgt$HHID15<-rownames(sumwgt)
#sumwgt<-sumwgt[-1,]
colnames(sumwgt)<-c("SumXwgt.Base","HHID15")

denominator$HHID15<-rownames(denominator)
#denominator<-denominator[-1,]

colnames(denominator)<-c("HHden","HHID15")
table (denominator$HHden)
GWS2015<-merge(denominator, sumwgt, by="HHID15")
head(GWS2015)
GWS2015$GWS<-GWS2015$SumXwgt.Base/GWS2015$HHden

ddk2<-dk2[,c("pid", "HHID15", "Eligi.pop", "attrition")]

GWS2015<-merge (ddk2, GWS2015, by="HHID15", all.x=T)
GWS2015$sampled2015<-1

save(GWS2015, file = file.path(base_path, temp_path, "GWS2015.RData"))

