load(file = file.path(base_path, temp_path, "dati.RData"))
load(file = file.path(base_path, temp_path, "dati_citi.RData"))
load(file = file.path(base_path, temp_path, "Baseweight.RData"))
load(file = file.path(base_path, temp_path, "GWS2015.RData"))


tot2015="TOT2015.txt"

tot2015 <- read.table(file= file.path(base_path, input_path, tot2015), header= TRUE, sep= "\t")

tot2015$Age_class<-ifelse(tot2015$Age_class==" 0-4",
                          " 00-04 ", tot2015$Age_class)
tot2015$Age_class<-ifelse(tot2015$Age_class==" 5-9",
                          " 05-09 ", tot2015$Age_class)

nrow(GWS2015)
names(GWS2015)
names (dati)

d<-dati[,c("pid","Xwgt15",
           "age_05", "age_09", "age_13", "age_15",
            "sex_15","relationtohead_15","region15" )]

#dd<-dati[, c("pid","Xwgt15")]

d<-merge (d, GWS2015, by="pid", all.x=T)
#d<-merge (d, dd, by="pid", all.x=T)
names(d)
nrow(d)
d$sampled2015<-ifelse(is.na(d$sampled2015),0,1)
d$age_15p<-ifelse(is.na(d$age_15),0,1)

table(d$sampled2015)
table(d$sex_15)
table(d$sex_15,d$sampled2015)
table(d$age_15p,d$sampled2015)
#       0     1 (=sampled in 2015)
# 0 18181   786 #786 missing age
# 1   168 15583

d<-d[d$sampled2015==1,]

d$age_15agg<-ifelse(is.na(d$age_15), d$age_13+2,d$age_15)
d$age_15agg<-ifelse(is.na(d$age_15agg), d$age_09+6,d$age_15agg)
d$age_15agg<-ifelse(is.na(d$age_15agg), d$age_05+10,d$age_15agg)
d$age_15aggp<-ifelse(is.na(d$age_15agg),0,1)

dd<-d[d$age_15p==0 & d$sampled2015==1,]
names(dd)
table(dd$age_15aggp)
table(d$relationtohead_15,  d$age_15aggp)

#     1
# 0 314 #individuals without age
# 1 472
#table(d$relationtohead_15,  d$age_15aggp)
#set the age il relation on the head


age_head<-d[d$relationtohead_15=="Head", c("HHID15", "age_15agg")]
head(age_head)
colnames(age_head)<-c("HHID15", "age_head")
d<-merge(d,age_head, by="HHID15", all.x=TRUE)
nrow(d)
d$age_15agg<-ifelse(d$age_15aggp==0 & d$relationtohead_15=="Spouse", d$age_head, d$age_15agg )
d$age_15agg<-ifelse(d$age_15aggp==0 & d$relationtohead_15=="Son/daughter of head",
                    d$age_head-20, d$age_15agg )
d$age_15agg<-ifelse(d$age_15aggp==0 & d$relationtohead_15=="Sister/Brother of head or spouse",
                    d$age_head, d$age_15agg )

d$age_15agg<-ifelse(d$age_15aggp==0 & d$relationtohead_15=="Parent of head or spouse",
                    d$age_head+20, d$age_15agg )
d$age_15agg<-ifelse(d$age_15aggp==0 & d$relationtohead_15=="Other relatives",
                    d$age_head-5, d$age_15agg )
d$age_15agg<-ifelse(d$age_15aggp==0 & d$relationtohead_15=="Non relative",
                    d$age_head-5, d$age_15agg )

d$age_15agg<-ifelse(d$age_15aggp==0 & d$relationtohead_15=="Nephew/Niece",
                    d$age_head-20, d$age_15agg )
d$age_15agg<-ifelse(d$age_15aggp==0 & d$relationtohead_15=="Grand Child",
                    d$age_head-20, d$age_15agg )

d$age_15aggp<-ifelse(is.na(d$age_15agg),0,1)

table(d$age_15aggp)

names(d)

d<-d[d$GWS>0 & !is.na(d$GWS),]#16368 individuals for the calibration

table(d$sex_15)
nrow(d)
###########################################
#Build the age class equal to total age class
############################################
d$age_class_samp= cut(d$age_15agg, c(-1,4,9,14,19,24,29,34,39,44,49,
                                   54,59,64,69,74,79,Inf), right=T)
yy<-as.data.frame (table(d$age_class_samp))
totals2015<-tot2015[-18,]
yy<-cbind(totals2015,yy)
yy<-yy[,c(1,4)]
colnames(yy)<-c("age_class", "age_class_samp")

d<-merge (d, yy, by="age_class_samp", all.x=T)
head(d)
names(d)
sample<-d[,c("pid","HHID15","region15", "sex_15","age_class","Xwgt15","GWS")]
head(sample)
str(sample)
sample$sex_15<-as.factor(sample$sex_15)
sample$age_class<-as.factor(sample$age_class)

#table(sample$age_class)


################################################
#Build design matrix for household calibration
#############################################
sample<-sample[order(sample$HHID15),]
head(sample)

F1 <- with(sample, outer(sex_15, levels(sex_15), `==`)*1)
colnames(F1) <- c(levels(sample$sex_15))
F2 <- with(sample, outer(age_class,
                         levels(age_class), `==`)*1)
colnames(F2) <- c(levels(sample$age_class))
head(F1)
head(F2)
FF1<-F1[,1]*F2
colnames(FF1) <- paste("Female.",sep="",
                              levels(sample$age_class))
FF2<-F1[,2]*F2
colnames(FF2) <- paste("Male.",sep="",
                       levels(sample$age_class))
age_class<-levels(sample$age_class)
head(FF1)
head(FF2)
FF<-as.data.frame(cbind(FF1, FF2))
sample<-cbind(sample,FF)
head(sample)
names(sample)

sample_region15<-sample[,c("HHID15", "region15")]
sample$region15<-NULL
sample_x<-sample[,c(2,7:40)]
sample_w<-sample[,c(2,5,6)]
sample_w$one<-1
###########################################
#Build the auxiliary variable per household
##############################################
library(dplyr)
house_sample<-sample_x %>%
  group_by(HHID15) %>%             
  summarise(across(everything(), sum))
house_sample<-as.data.frame(house_sample)
head(house_sample)

house_sample_w<-sample_w %>%
  group_by(HHID15) %>%             
  summarise(Xwgt15=mean(Xwgt15), GWS.adj=mean(GWS), x=sum(one))
house_sample_w<-as.data.frame(house_sample_w)
head(house_sample_w)

house_sample<-merge(house_sample_w, 
                    house_sample, by="HHID15")

####################################################
#Build the known totals
####################################################
totals2015
tot_f<-as.data.frame(t(totals2015[,3]))
colnames (tot_f)<-paste("Female.",sep="",
                             (age_class))
tot_f

tot_m<-t(totals2015[,2])
colnames (tot_m)<-paste("Male.",sep="",
                        (age_class))
tot_m
tot<-as.data.frame(cbind(tot_f,tot_m))
tot
colnames(tot)<-paste("x",sep="",rep(1:34))

################################################
names(house_sample)
colnames(house_sample)<-c("HHID15","Xwgt15","GWS","x",
                                paste("x",sep="",rep(1:34)))
names(house_sample)

rm(age_head,d, dati, datic,dd,F1,F2,FF,FF1,FF2,GWS2015,
   tot_f,
   tot_m, tot2015, totals2015, yy)

save(house_sample, file = file.path(base_path, temp_path, "hous_sample_aux_var_calibration2015.RData"))
save(sample, file = file.path(base_path, temp_path, "sample_for_calibration2015.RData"))
save(tot, file = file.path(base_path, temp_path, "tot_ready_for_calibration2015.RData"))

#############part new
qqq<-(table(sample_region15$HHID15  ,sample_region15$region15))
head(qqq)
class(qqq)
names(house_sample)
x35<-ifelse(qqq[,"Central"]>0,1,0)
x36<-ifelse(qqq[,"Eastern"]>0,1,0)
x37<-ifelse(qqq[,"Northern"]>0,1,0)
x38<-ifelse(qqq[,"Western"]>0,1,0)

house_sample_new<-cbind(house_sample, x35,x36,x37,x38)
head(house_sample_new)

#########add number of hhs by region. source 2014 census
x35<- 2298942 #Central
x36<- 1743460 #Eastern
x37<- 1349162 #Northern
x38<- 1912506 #Western
tot_new<-cbind(tot, x35,x36,x37,x38)
tot_new
class(tot)


save(house_sample_new, file = file.path(base_path, temp_path, "hous_sample_aux_var_calibration2015_new.RData"))
save(tot_new, file = file.path(base_path, temp_path, "tot_ready_for_calibration2015_new.RData"))
