####################################################
#Build the target variable for the individual
####################################################

load(file = file.path(base_path, temp_path, "hous_sample_aux_var_calibration2015.RData"))
load(file = file.path(base_path, temp_path, "sample_for_calibration2015.RData"))


varia="unps_09_13_15_variables.txt"
varia<- read.table(file= file.path(base_path, temp_path,varia), header= TRUE, sep= "\t", 
                   colClasses = c("hhid"="factor", "HHID09"="factor", "HHID13"="factor", "HHID15"="factor",
                                  "pid"="factor", "PID09"="factor", "PID13"="factor", "PID15"="factor"),
                   na.strings= NA, quote="\"", dec= ".", strip.white= TRUE, comment.char= "")

varia<-varia[,c(
  "hhid", "pid","sex_09","age_09","hhsize_09","poor09",
  "tot_employment09",    
  "lit_pop09","employees09","employer09","self_employment09",
  "industry109","totincome09","pcinc09", "electricity09",
  "safewater09", "runwater09","ownhome09",        
  "sex_13","age_13","hhsize_13", "poor13","tot_employment13",    
  "lit_pop13","employees13","employer13","self_employment13",
  "industry113","totincome13","pcinc13", "electricity13",
  "safewater13", "runwater13","ownhome13",
  "sex_15","age_15","hhsize_15", "poor15","tot_employment15",    
  "lit_pop15","employees15","employer15","self_employment15",
  "industry115","totincome15","pcinc15", "electricity15",
  "safewater15", "runwater15","ownhome15")]

nrow(sample)
nrow(varia)
pid<-as.data.frame(sample[,c("pid", "HHID15")])
colnames(pid)<-c("pid", "HHID15")
nrow(pid)

varia<-merge (pid, varia, by="pid", all.x=TRUE)
nrow(varia)

varia<-varia[order(varia$HHID15),]

varia$btot_employment15<-ifelse (is.na(varia$tot_employment15), 999 , varia$tot_employment15)
varia$blit_pop15<-ifelse (is.na(varia$lit_pop15), 999 , varia$lit_pop15)
varia$bemployees15<-ifelse (is.na(varia$employees15), 999 , varia$employees15)
varia$bemployer15<-ifelse (is.na(varia$employer15), 999 , varia$employer15)
varia$bself_employment15<-ifelse (is.na(varia$self_employment15), 999 , varia$self_employment15)
varia$bindustry115<-ifelse (is.na(varia$industry115), 999 , varia$industry115)

varia$btot_employment15<-as.factor(varia$btot_employment15)
varia$blit_pop15<-as.factor(varia$blit_pop15)
varia$bemployees15<-as.factor(varia$bemployees15)
varia$bemployer15<-as.factor(varia$bemployer15)
varia$bself_employment15<-as.factor(varia$bself_employment15)
varia$bindustry115<-as.factor(varia$bindustry115)

head(varia)
V1 <- as.data.frame(with(varia, outer(btot_employment15, levels(btot_employment15), `==`)*1))
V2 <- as.data.frame(with(varia, outer(blit_pop15, levels(blit_pop15), `==`)*1))
V3 <- as.data.frame(with(varia, outer(bemployees15, levels(bemployees15), `==`)*1))
V4 <- as.data.frame(with(varia, outer(bemployer15, levels(bemployer15), `==`)*1))
V5 <- as.data.frame(with(varia, outer(bself_employment15, levels(bself_employment15), `==`)*1))
V6 <- as.data.frame(with(varia, outer(bindustry115, levels(bindustry115), `==`)*1))

#Delete last column with 999 =missing values
V1<-V1[,-ncol(V1)]
V2<-V2[,-ncol(V2)]
V3<-V3[,-ncol(V3)]
V4<-V4[,-ncol(V4)]
V5<-V5[,-ncol(V5)]
V6<-V6[,-ncol(V6)]


varia$tot_employment15<-as.factor(varia$tot_employment15)
varia$lit_pop15<-as.factor(varia$lit_pop15)
varia$employees15<-as.factor(varia$employees15)
varia$employer15<-as.factor(varia$employer15)
varia$self_employment15<-as.factor(varia$self_employment15)
varia$industry115<-as.factor(varia$industry115)

colnames(V1) <-paste("tot_employment15",sep=".", c(levels(varia$tot_employment15)))
colnames(V2) <-paste("lit_pop15",sep=".", c(levels(varia$lit_pop15)))
colnames(V3) <-paste("employees15",sep=".", c(levels(varia$employees15)))
colnames(V4) <-paste("employer15",sep=".", c(levels(varia$employer15)))
colnames(V5) <-paste("self_employment15",sep=".", c(levels(varia$self_employment15)))
colnames(V6) <-paste("industry115",sep=".", c(levels(varia$industry115)))

head(varia)
HHID15<-as.data.frame(varia[,"HHID15"])
colnames(HHID15)<-"HHID15"
V<-cbind(HHID15,V1,V2,V3,V4,V5,V6)
head(V)


library(dplyr)
var_hous<-V %>%
  group_by(HHID15) %>%             
  summarise(across(everything(), sum))
var_hous<-as.data.frame(var_hous)
head(var_hous)

names(varia)

household_variable<-varia[,c("HHID15", "poor15","totincome15","pcinc15","electricity15",
                             "safewater15","runwater15","ownhome15")]
str(household_variable)
var_proper_hous<-household_variable %>%
group_by(HHID15) %>%             
  summarise(across(everything(), mean, na.rm = TRUE))
var_proper_hous<-as.data.frame(var_proper_hous)
head(var_proper_hous)

var_proper_hous$poor15<-ifelse(is.na(var_proper_hous$poor15),999,
                                    var_proper_hous$poor15)
var_proper_hous$electricity15<-ifelse(is.na(var_proper_hous$electricity15),999,
                                    var_proper_hous$electricity15)
var_proper_hous$safewater15<-ifelse(is.na(var_proper_hous$safewater15),999,
                                    var_proper_hous$safewater15)
var_proper_hous$runwater15<-ifelse(is.na(var_proper_hous$runwater15),999,
                                    var_proper_hous$runwater15)
var_proper_hous$ownhome15<-ifelse(is.na(var_proper_hous$ownhome15),999,
                                    var_proper_hous$ownhome15)
nrow(var_proper_hous)

var_hous_for_cal<-merge(house_sample, var_proper_hous, by="HHID15")
var_hous_for_cal<-merge(var_hous_for_cal, var_hous, by="HHID15")
str(var_hous_for_cal)
var_hous_for_cal$poor15<-as.factor(var_hous_for_cal$poor15)
var_hous_for_cal$electricity15<-as.factor(var_hous_for_cal$electricity15)
var_hous_for_cal$safewater15<-as.factor(var_hous_for_cal$safewater15)
var_hous_for_cal$runwater15<-as.factor(var_hous_for_cal$runwater15)
var_hous_for_cal$ownhome15<-as.factor(var_hous_for_cal$ownhome15)


save(var_hous_for_cal, file = file.path(base_path, temp_path, "hous_Sample_for_calibration2015.RData"))
