
####################################################
#Build the target variable for the individual
####################################################


load(file = file.path(base_path, temp_path, "hous_Sample_for_calibration2015.RData"))
load(file = file.path(base_path, temp_path, "Sample_for_calibration2015.RData"))
load(file = file.path(base_path, temp_path, "tot_ready_for_calibration2015.RData"))


tot2015="TOT2015.txt"
tot2015 <- read.table(file=file.path(base_path, input_path, tot2015), header= TRUE, sep= "\t")
tot2015$Age_class<-ifelse(tot2015$Age_class==" 0-4",
                          " 00-04 ", tot2015$Age_class)
tot2015$Age_class<-ifelse(tot2015$Age_class==" 5-9",
                          " 05-09 ", tot2015$Age_class)

names(var_hous_for_cal)

devtools::install_github("DiegoZardetto/ReGenesees")

library(ReGenesees)
des<-e.svydesign(data=var_hous_for_cal,ids=~HHID15,
                 weights=~GWS)

bounds.hint(des, tot,
            calmodel = ~x1+x2+x3+x4+x5+x6+x7+x8+x9+x10+
              x11+x12+x13+x14+x15+x16+x17+x18+x19+x20+
              x21+x22+x23+x24+x25+x26+x27+x28+x29+x30+
              x31+x32+x33+x34-1)


cal<-e.calibrate(des, tot, 
                 calmodel=~x1+x2+x3+x4+x5+x6+x7+x8+x9+x10+
                   x11+x12+x13+x14+x15+x16+x17+x18+x19+x20+
                   x21+x22+x23+x24+x25+x26+x27+x28+x29+x30+
                   x31+x32+x33+x34-1, calfun = c("logit"),
                 bounds = c(0.55,2.5))

summary(weights(cal))
g.range(cal)
check.cal(cal) 

weight.cal<-cal$variables
nrow(weight.cal)
head(weight.cal)
sum(weight.cal$x)
tot2015

save(weight.cal, file = file.path(base_path, temp_path, "hous_Sample_for_calibration2015_GWSMcal.RData"))

