#########
#New calibration for presentation of October 18 2021
##################


####################################################
#Build the target variable for the individual
####################################################
load(file = file.path(base_path, temp_path, "hous_Sample_for_calibration2015_GWSMcal.RData"))
load(file = file.path(base_path, temp_path, "hous_sample_aux_var_calibration2015_new.RData"))

load(file = file.path(base_path, temp_path, "Sample_for_calibration2015.RData"))
load(file = file.path(base_path, temp_path, "tot_ready_for_calibration2015.RData"))


tot2015="TOT2015.txt"
tot2015 <- read.table(file= file.path(base_path, input_path, tot2015), header= TRUE, sep= "\t")
tot2015$Age_class<-ifelse(tot2015$Age_class==" 0-4",
                          " 00-04 ", tot2015$Age_class)
tot2015$Age_class<-ifelse(tot2015$Age_class==" 5-9",
                          " 05-09 ", tot2015$Age_class)
names(house_sample_new)
newx<-house_sample_new[, c("HHID15", "x35","x36", "x37","x38")]
var_hous_for_cal_new<-merge (weight.cal, newx, by="HHID15")

names(var_hous_for_cal_new)[names(var_hous_for_cal_new)
                            == 'GWS.cal'] <- 'GWS.cal.noHHs'
library(ReGenesees)
des<-e.svydesign(data=var_hous_for_cal_new,ids=~HHID15,
                 weights=~GWS)

bounds.hint(des, tot_new,
            calmodel = ~x1+x2+x3+x4+x5+x6+x7+x8+x9+x10+
              x11+x12+x13+x14+x15+x16+x17+x18+x19+x20+
              x21+x22+x23+x24+x25+x26+x27+x28+x29+x30+
              x31+x32+x33+x34+x35+x36+x37+x38-1)


cal<-e.calibrate(des, tot_new, 
                 calmodel=~x1+x2+x3+x4+x5+x6+x7+x8+x9+x10+
                   x11+x12+x13+x14+x15+x16+x17+x18+x19+x20+
                   x21+x22+x23+x24+x25+x26+x27+x28+x29+x30+
                   x31+x32+x33+x34+x35+x36+x37+x38-1, calfun = c("logit"),
                 bounds = c(0.037,2.5))


summary(weights(cal))
g.range(cal)
check.cal(cal) 

weight.calHHs<-cal$variables
nrow(weight.calHHs)
head(weight.calHHs)
sum(weight.cal$x)
tot2015
svystatTM(cal, y= ~ x1+x2+x3+x4+x5+x6+x7+x8+x9+x10+
            x11+x12+x13+x14+x15+x16+x17+x18+x19+x20+
            x21+x22+x23+x24+x25+x26+x27+x28+x29+x30+
            x31+x32+x33+x34+x35+x36+x37+x38,  estimator= "Total", 
          conf.int= TRUE, conf.lev= 0.95, deff= FALSE, na.rm= FALSE)

names(weight.cal)
head(weight.cal)
svystatTM(cal, y= ~ poor15+electricity15+safewater15+ownhome15,  estimator= "Mean", 
          conf.int= TRUE, conf.lev= 0.95, deff= FALSE, na.rm= FALSE)

svystatTM(cal, y= ~ tot_employment15.0+tot_employment15.1+
            tot_employment15.99+lit_pop15.0+lit_pop15.1,  
          estimator= "Tot", 
          conf.int= TRUE, conf.lev= 0.95, deff= FALSE, na.rm= FALSE)


weight.calHHs<-weight.calHHs[,c("HHID15","GWS.cal.noHHs","GWS.cal")]
names(sample)
names(weight.calHHs)
nrow(sample)
nrow(weight.calHHs)
weight.cal_final<-merge (sample, weight.calHHs, by="HHID15",
                         all.y = TRUE)

nrow(weight.cal_final)
names(weight.cal_final)

write.table(weight.cal_final,file = file.path(base_path, temp_path,"Uganda_cal2015HHs.txt"),
            sep=";",row.names=F,col.names=TRUE,quote=FALSE)
head(weight.cal_final)
